package com.io.yutian.aulib.command.argument;

import java.util.function.Function;
import java.util.function.Predicate;

public class ArgumentType<T> {

    private final String name;

    private Predicate<String> predicate;
    private Function<String, T> function;

    public ArgumentType(String name, Predicate<String> predicate, Function<String, T> function) {
        this.name = name;
        this.predicate = predicate;
        this.function = function;
    }

    public String getName() {
        return name;
    }

    public boolean test(String string) {
        return predicate.test(string);
    }

    public T get(String t) {
        return function.apply(t);
    }

}
