package com.io.yutian.aulib.gui.button;

import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;

import java.util.function.BiConsumer;

public class Button {

    private ItemStack itemStack;

    private BiConsumer<Player, ClickType> clickConsumer;

    private boolean asynchronous = false;
    private boolean playSound = true;

    public Button(ItemStack itemStack) {
        this.itemStack = itemStack;
    }

    public void setItemStack(ItemStack itemStack) {
        this.itemStack = itemStack;
    }

    public Button click(BiConsumer<Player, ClickType> consumer) {
        this.clickConsumer = consumer;
        return this;
    }

    public Button asyn() {
        this.asynchronous = true;
        return this;
    }

    public Button noSound() {
        this.playSound = false;
        return this;
    }

    public ItemStack getItemStack() {
        return itemStack;
    }

    public BiConsumer<Player, ClickType> getClickConsumer() {
        return clickConsumer;
    }

    public boolean isAsynchronous() {
        return asynchronous;
    }

    public boolean isPlaySound() {
        return playSound;
    }

}
