package com.io.yutian.aulib.listener;

import com.io.yutian.aulib.gui.IGui;
import com.io.yutian.aulib.gui.IGuiDrag;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.inventory.*;
import org.bukkit.inventory.InventoryHolder;
import org.bukkit.plugin.Plugin;

public final class GuiHandlerListener extends IListener {

    public GuiHandlerListener(Plugin plugin) {
        super(plugin);
    }

    @EventHandler(priority = EventPriority.HIGHEST)
    public void onInventoryClick(InventoryClickEvent event) {
        if (event.getInventory().getHolder() == null) {
            return;
        }
        Player player = (Player) event.getWhoClicked();
        InventoryHolder holder = event.getInventory().getHolder();
        if (holder instanceof IGui iGui) {
            if (event.getClickedInventory() != event.getInventory()) {
                if (event.getAction().equals(InventoryAction.MOVE_TO_OTHER_INVENTORY) || event.getAction().equals(InventoryAction.COLLECT_TO_CURSOR)) {
                    event.setCancelled(true);
                    return;
                }
            }
            if (event.getAction().equals(InventoryAction.HOTBAR_SWAP) || event.getAction().equals(InventoryAction.HOTBAR_MOVE_AND_READD)) {
                event.setCancelled(true);
                player.getInventory().setItemInOffHand(player.getInventory().getItemInOffHand());
                return;
            }
            int slot = event.getRawSlot();
            iGui.handler(player, slot, event);
        }
    }

    @EventHandler
    public void onInventoryDrag(InventoryDragEvent event) {
        if (event.getInventory().getHolder() != null) {
            InventoryHolder inventoryHolder = event.getInventory().getHolder();
            if (inventoryHolder instanceof IGui) {
                if (inventoryHolder instanceof IGuiDrag iGuiDrag) {
                    iGuiDrag.onInventoryDrag(event);
                } else {
                    event.setCancelled(true);
                }
            }
        }
    }

    @EventHandler
    public void onInventoryClose(InventoryCloseEvent event) {
        if (event.getInventory().getHolder() != null) {
            InventoryHolder inventoryHolder = event.getInventory().getHolder();
            if (inventoryHolder instanceof IGui iGui) {
                iGui.close(event);
            }
        }
    }

}
