package com.io.yutian.aulib.sql.builder;

import com.io.yutian.aulib.sql.api.SQLBuilder;
import com.io.yutian.aulib.sql.manager.SQLManagerImpl;
import org.jetbrains.annotations.NotNull;

import java.util.Objects;

public abstract class AbstractSQLBuilder implements SQLBuilder {

    @NotNull
    final SQLManagerImpl sqlManager;

    public AbstractSQLBuilder(@NotNull SQLManagerImpl manager) {
        Objects.requireNonNull(manager, "SQLManager must not be null");
        this.sqlManager = manager;
    }

    @Override
    public @NotNull SQLManagerImpl getManager() {
        return this.sqlManager;
    }
}
