package com.io.yutian.aulib.sql.builder.impl;

import com.io.yutian.aulib.sql.action.query.PreparedQueryActionImpl;
import com.io.yutian.aulib.sql.action.query.QueryActionImpl;
import com.io.yutian.aulib.sql.api.action.query.PreparedQueryAction;
import com.io.yutian.aulib.sql.api.action.query.QueryAction;
import com.io.yutian.aulib.sql.api.builder.QueryBuilder;
import com.io.yutian.aulib.sql.api.builder.TableQueryBuilder;
import com.io.yutian.aulib.sql.builder.AbstractSQLBuilder;
import com.io.yutian.aulib.sql.manager.SQLManagerImpl;
import org.jetbrains.annotations.NotNull;

import java.util.Objects;

public class QueryBuilderImpl extends AbstractSQLBuilder implements QueryBuilder {
    public QueryBuilderImpl(@NotNull SQLManagerImpl manager) {
        super(manager);
    }

    @Override
    @Deprecated
    public QueryAction withSQL(@NotNull String sql) {
        Objects.requireNonNull(sql, "sql could not be null");
        return new QueryActionImpl(getManager(), sql);
    }

    @Override
    public PreparedQueryAction withPreparedSQL(@NotNull String sql) {
        Objects.requireNonNull(sql, "sql could not be null");
        return new PreparedQueryActionImpl(getManager(), sql);
    }

    @Override
    public TableQueryBuilder inTable(@NotNull String tableName) {
        Objects.requireNonNull(tableName, "tableName could not be null");
        return new TableQueryBuilderImpl(getManager(), tableName);
    }

}
